      subroutine cam_error(c,n,a,f,stat)

      implicit none

      include '/usr/acq/vme/cam_fast.for'
  
      integer*4 stat,c,n,a,f
      integer*4 i
      character*64 mess
      character*20 msg


      if (stat.eq.0) return     !return if good

      if (stat .eq. NOQ) then
         msg = 'GOOD X   BAD Q'
      elseif (stat .eq. NOX) then
         msg = 'GOOD Q   BAD X'
      elseif (stat .eq. NOX_NOQ) then
         msg = 'BAD  Q   BAD X'
      elseif (stat .eq. TIMEOUT) then
         msg = 'Timeout'
      elseif (stat .eq. ILL_CRATE) then
         msg = 'Illegal Crate'
      elseif (stat .eq. ILL_MODULE) then
         msg = 'Illegal Module'
      elseif (stat .eq. ILL_ADDRESS) then
         msg = 'Illegal Address'
      elseif (stat .eq. ILL_FUNCTION) then
         msg = 'Illegal Function'
      elseif (stat .eq. CRATE_OFF_LINE) then
         msg = 'Crate Off Line'
      else
         msg = 'Unknown error code'
      endif

      write(mess,10) c,n,a,f,msg
10    format(' CAM ERROR-C,N,A,F=',4I3,'  'A)

20    write(*,9000) mess       !send error message
9000  format(a)
      return
      end
